CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes
csl::AmbisonicPanner Class Reference

Ambisonic Panner Wraps around the different ambisonic classes, providing a single interface for encoding, manipulating and decoding (i.e. panning) multiple UnitGenerators. More...

`#include <AmbisonicPanner.h>`

Inheritance diagram for csl::AmbisonicPanner:

List of all members.

## Public Member Functions
| AmbisonicPanner (unsigned order=1, SpeakerLayout *layout=SpeakerLayout::defaultSpeakerLayout())
| AmbisonicPanner (unsigned hOrder, unsigned vOrder, SpeakerLayout *layout=SpeakerLayout::defaultSpeakerLayout())
| ~AmbisonicPanner ()
void | addSource (SpatialSource &s)
| Implement Panner's addSource, inserting an Encoder to each source.
void | removeSource (SpatialSource &s)
| Remove a sound source.
void | rotate (float amount)
void | nextBuffer (Buffer &outputBuffer) throw (CException)
| fill the buffer with the next buffer_length of values
void | dump ()
| pretty-print the receiver
void | setSpeakerLayout (SpeakerLayout *aLayout)
| Set the speaker layout to be used by this panner. The panner will request the default layout if not set.
unsigned | numSources ()
virtual void | update (void *arg)
| Called when the speaker layout changes.
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
virtual bool | isActive ()
| query whether I'm currently active (Envelopes can go inactive)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
virtual void | trigger ()
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)

## Public Attributes
float | mPeriod
| virtual destructor (don't notify or delete observers in this version)
int | mKey
| key selector (e.g., MIDI chan) I receive update() mesages from my model;

## Protected Member Functions
virtual void * | cache ()
| create the cache
virtual void | speakerLayoutChanged ()
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer

## Protected Attributes
AmbisonicMixer * | mMixer
| Print info about this instance.
AmbisonicDecoder * | mDecoder
AmbisonicRotator * | mRotator
UGenVector | mSources
| SpatialSource... refers to its input UGen, but with the knowledge of its position within a space.
vector< void * > | mCache
| Vector of pointers to the prior I/O data.
SpeakerLayout * | mSpeakerLayout
| If null, it will use the default layout by calling SpeakerLayout::defaultSpeakerLayout();.
Buffer | mTempBuffer
| Buffer used to temporarily hold input source data.
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number

## Detailed Description

Ambisonic Panner Wraps around the different ambisonic classes, providing a single interface for encoding, manipulating and decoding (i.e. panning) multiple UnitGenerators.

Definition at line 22 of file AmbisonicPanner.h.

## Constructor & Destructor Documentation

AmbisonicPanner::AmbisonicPanner | ( | unsigned | order = `1`,
|  | SpeakerLayout * | layout = `SpeakerLayout::defaultSpeakerLayout()`
| ) |  |

Definition at line 13 of file AmbisonicPanner.cpp.

References csl::kIgnore, mDecoder, mMixer, mRotator, and csl::UnitGenerator::setCopyPolicy().

AmbisonicPanner::AmbisonicPanner | ( | unsigned | hOrder,
|  | unsigned | vOrder,
|  | SpeakerLayout * | layout = `SpeakerLayout::defaultSpeakerLayout()`
| ) |  |

Definition at line 22 of file AmbisonicPanner.cpp.

References csl::kIgnore, mDecoder, mMixer, mRotator, and csl::UnitGenerator::setCopyPolicy().

AmbisonicPanner::~AmbisonicPanner | ( |  | ) |

Definition at line 29 of file AmbisonicPanner.cpp.

References mDecoder, mMixer, and mRotator.

## Member Function Documentation

void AmbisonicPanner::addSource | ( | SpatialSource & | s | ) |
| virtual

Implement Panner's addSource, inserting an Encoder to each source.

Reimplemented from csl::SpatialPanner.

Definition at line 39 of file AmbisonicPanner.cpp.

References csl::AmbisonicMixer::addInput(), and mMixer.

void AmbisonicPanner::removeSource | ( | SpatialSource & | s | ) |
| virtual

Remove a sound source.

Reimplemented from csl::SpatialPanner.

Definition at line 45 of file AmbisonicPanner.cpp.

void AmbisonicPanner::rotate | ( | float | amount | ) |

Definition at line 59 of file AmbisonicPanner.cpp.

References mRotator, and csl::AmbisonicRotator::setRotate().

void AmbisonicPanner::nextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)
| virtual

fill the buffer with the next buffer_length of values

Implements csl::SpatialPanner.

Definition at line 67 of file AmbisonicPanner.cpp.

References csl::logMsg().

void csl::AmbisonicPanner::dump | ( | void |  | ) |
| inline virtual

pretty-print the receiver

Reimplemented from csl::UnitGenerator.

Definition at line 36 of file AmbisonicPanner.h.

void SpatialPanner::setSpeakerLayout | ( | SpeakerLayout * | aLayout | ) |
| inherited

Set the speaker layout to be used by this panner. The panner will request the default layout if not set.

Definition at line 25 of file SpatialPanner.cpp.

References csl::Model::attachObserver(), csl::Model::detachObserver(), csl::SpatialPanner::mSpeakerLayout, and csl::SpatialPanner::speakerLayoutChanged().

Referenced by csl::SpatialPanner::SpatialPanner(), and csl::SpatialPanner::update().

unsigned csl::SpatialPanner::numSources | ( |  | ) |
| inline inherited

Definition at line 32 of file SpatialPanner.h.

References csl::SpatialPanner::mSources.

Referenced by csl::Spatializer::numSources().

void SpatialPanner::update | ( | void * | arg | ) |
| virtual inherited

Called when the speaker layout changes.

Called when the speaker layout changes, so panners update their data. This method is implemented only by the Panner class, and depending on the message sent, it calls the appropriate method implemented by subclasses. For example, when the speaker layout changes, the method calls "speakerLayoutChanged()", which should be implemented by subclasses interested to react to such change.

Implements csl::Observer.

Definition at line 83 of file SpatialPanner.cpp.

References csl::SpeakerLayout::defaultSpeakerLayout(), csl::SpatialPanner::mSpeakerLayout, csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::speakerLayoutChanged().

virtual void csl::SpatialPanner::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| inline virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented from csl::UnitGenerator.

Reimplemented in csl::VBAP.

Definition at line 42 of file SpatialPanner.h.

void * SpatialPanner::cache | ( |  | ) |
| protected virtual inherited

create the cache

Reimplemented in csl::VBAP, and csl::BinauralPanner.

Definition at line 72 of file SpatialPanner.cpp.

Referenced by csl::SpatialPanner::addSource().

virtual void csl::SpatialPanner::speakerLayoutChanged | ( |  | ) |
| inline protected virtual inherited

Reimplemented in csl::VBAP.

Definition at line 57 of file SpatialPanner.h.

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::update().

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), csl::AmbisonicUnitGenerator::initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

virtual bool csl::UnitGenerator::isActive | ( |  | ) |
| inline virtual inherited

query whether I'm currently active (Envelopes can go inactive)

Reimplemented in csl::Joiner, csl::Effect, csl::RandEnvelope, csl::SoundCue, csl::Stereoverb, csl::Abst_SoundFile, csl::Envelope, csl::Instrument, csl::Mixer, and csl::KarplusString.

Definition at line 249 of file CSL_Core.h.

Referenced by csl::Instrument::isActive(), csl::Port::isActive(), csl::Mixer::nextBuffer(), csl::BinauralPanner::nextBuffer(), csl::AmbisonicMixer::nextBuffer(), and csl::VBAP::nextBuffer().

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

virtual void csl::UnitGenerator::trigger | ( | void |  | ) |
| inline virtual inherited

Reimplemented in csl::Joiner, csl::Effect, csl::RandEnvelope, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::LineSegment, and csl::KarplusString.

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Instrument::play(), csl::Instrument::release(), and csl::Port::trigger().

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

## Member Data Documentation

AmbisonicMixer* csl::AmbisonicPanner::mMixer
| protected

Print info about this instance.

Definition at line 36 of file AmbisonicPanner.h.

Referenced by addSource(), AmbisonicPanner(), and ~AmbisonicPanner().

AmbisonicDecoder* csl::AmbisonicPanner::mDecoder
| protected

Definition at line 40 of file AmbisonicPanner.h.

Referenced by AmbisonicPanner(), and ~AmbisonicPanner().

AmbisonicRotator* csl::AmbisonicPanner::mRotator
| protected

Definition at line 41 of file AmbisonicPanner.h.

Referenced by AmbisonicPanner(), rotate(), and ~AmbisonicPanner().

UGenVector csl::SpatialPanner::mSources
| protected inherited

SpatialSource... refers to its input UGen, but with the knowledge of its position within a space.

Vector of pointers to the inputs

Definition at line 49 of file SpatialPanner.h.

Referenced by csl::SimplePanner::addSource(), csl::SpatialPanner::addSource(), csl::SpatialPanner::numSources(), csl::SimplePanner::removeSource(), and csl::SpatialPanner::removeSource().

vector<void *> csl::SpatialPanner::mCache
| protected inherited

Vector of pointers to the prior I/O data.

Definition at line 50 of file SpatialPanner.h.

Referenced by csl::SpatialPanner::addSource(), and csl::SpatialPanner::removeSource().

SpeakerLayout* csl::SpatialPanner::mSpeakerLayout
| protected inherited

If null, it will use the default layout by calling SpeakerLayout::defaultSpeakerLayout();.

Definition at line 52 of file SpatialPanner.h.

Referenced by csl::SpatialPanner::setSpeakerLayout(), csl::VBAP::speakerLayoutChanged(), csl::SpatialPanner::update(), csl::VBAP::VBAP(), csl::SpatialPanner::~SpatialPanner(), csl::StereoPanner::~StereoPanner(), and csl::SurroundPanner::~SurroundPanner().

Buffer csl::SpatialPanner::mTempBuffer
| protected inherited

Buffer used to temporarily hold input source data.

Definition at line 54 of file SpatialPanner.h.

Referenced by csl::SpatialPanner::SpatialPanner(), and csl::SpatialPanner::~SpatialPanner().

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), csl::SndFileInstrument::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicUnitGenerator::initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

float csl::Observer::mPeriod
| inherited

virtual destructor (don't notify or delete observers in this version)

max update rate

Definition at line 286 of file CGestalt.h.

Referenced by csl::Model::attachObserver().

int csl::Observer::mKey
| inherited

key selector (e.g., MIDI chan) I receive update() mesages from my model;

Definition at line 289 of file CGestalt.h.

Referenced by csl::Model::attachObserver().

The documentation for this class was generated from the following files:

- CSL/Spatializers/Ambisonic/AmbisonicPanner.h
- CSL/Spatializers/Ambisonic/AmbisonicPanner.cpp